﻿-- ----------------------------------------------------------------------- --
--     Moncai Hotkey Label Improver
--     Copyright (c) 2006-2014 Moncaí
--
--     May be copied and distributed freely as long as you do not
--     change this file.
--     
-- ----------------------------------------------------------------------- --

-- Change bindingtext
old_ActionButton_UpdateHotkeys = ActionButton_UpdateHotkeys;

--~ GLOBINDS = {}

-- FrameXML/ActionButton.lua:197-222
function ActionButton_UpdateHotkeys (self, actionButtonType)
	local id;
	if ( not actionButtonType ) then
		actionButtonType = "ACTIONBUTTON";
		id = self:GetID();
	else
		if ( actionButtonType == "MULTICASTACTIONBUTTON" ) then
			id = self.buttonIndex;
		else
			id = self:GetID();
		end
	end

	local hotkey = _G[self:GetName().."HotKey"];
	local key = GetBindingKey(actionButtonType..id) or
                GetBindingKey("CLICK "..self:GetName()..":LeftButton");

	-- // -- MODDED
		
	local text = GetBindingText(key, "KEY_", false);
	
	local CTRL, NUM = "CTRL", "Num Pad"
	local C_ab, N_ab = "c", "N"
	
	if (GetLocale() == "deDE") then 			-- // -- deDE
		NUM, N_ab = "Ziffernblock", "Z"
		CTRL, C_ab = "STRG", "c"
	end

	-- Specials
	text = string.gsub(text,"Middle Mouse", "Mid");
	text = string.gsub(text,"Mouse Button.", "M");
	
	text = string.gsub(text,"Num Lock", "Num");
	
	-- Alt, Control, Shift and Numpad
	text = string.gsub(text, "ALT."..CTRL..".".."SHIFT."..NUM..".", "a"..C_ab.."s"..N_ab);
	text = string.gsub(text, "ALT."..CTRL.."."..NUM..".", "a"..C_ab..N_ab);
	text = string.gsub(text, CTRL..".".."SHIFT."..NUM..".", C_ab.."s"..N_ab);
	text = string.gsub(text, "ALT.SHIFT."..NUM..".", "as"..N_ab);

	-- Unmodified Num Pad
	text = string.gsub(text, NUM, N_ab);
	
	-- Alt Control F# binding for Logitech G# Macro keys
	text = string.gsub(text,"ALT."..CTRL..".F", "G");
	
	-- Alt Control Shift with any key
	text = string.gsub(text,"ALT."..CTRL..".SHIFT.", "a"..C_ab.."s");
	text = string.gsub(text,"ALT.SHIFT.", "as");
	text = string.gsub(text,CTRL..".SHIFT.", C_ab.."s");
	text = string.gsub(text,"ALT."..CTRL..".", "a"..C_ab);
	text = string.gsub(text,CTRL, C_ab);
	text = string.gsub(text,"ALT", "a");
	text = string.gsub(text,"SHIFT", "s");

--~ 	if key and (key ~= text) then
--~ 		local bind = string.format("[%s] -> {%s}", key or "?", text or "?")
--~ 		print(bind)
--~ 		GLOBINDS[key] = bind
--~ 	end
--~ 	Spew("Binds", GLOBINDS)

	-- // -- DEDDOM
	
	if ( text == "" ) then
		hotkey:SetText(RANGE_INDICATOR);
		hotkey:Hide();
	else
		hotkey:SetText(text);
		hotkey:Show();
	end
	
end

local which = GetCurrentBindingSet()
if which then
	LoadBindings(which)
end
